import json
from CellFrame.Common import Datum, DatumTx, TxOut, TxIn, TxToken, TxSig, TxOutCondSubtypeSrvStakeLock, TxInCond,TxOutExt


def json_dump(data):
    return json.dumps(data)

def json_load(data):
    try:
        return json.loads(data)
    except:
        return None


def find_tx_out(tx, out_type):
    try:
        return next(filter(lambda x: isinstance(x, out_type), tx.getItems()))
    except:
        return None

def get_tx_items(tx, out_type):
    try:
        return list(filter(lambda x: isinstance(x, out_type), tx.getItems()))
    except:
        return None    

def get_tsd_data(tsd_list, type_tsd):
    try:
        return next(filter(lambda x: x.type == type_tsd, tsd_list)).data
    except:
        return None  

def get_tx_outs(tx, out_type):
    try:
        return list(filter(lambda x: isinstance(x, out_type), tx.getItems()))
    except:
        return None

class ListCache:
    def __init__(self, capacity):
        self.capacity = capacity
        self.data = []


    def add(self, data):
        self.data.append(data)
        if len(self.data) > self.capacity:
            self.data.pop(0)

    def data(self):
        return self.data
        
def net_by_name(NETS, netname):
    for net in NETS:
        if net.name == netname:
            return net
