from typing import NewType
from enum import Enum

from CellFrame.Common import TxIn, TxInCond, TxOut, TxOutCond, TxPkey, TxSig, TxToken, TxReceipt, TxOutExt, TxTSD, \
    TxOutCondSubtypeSrvStakeLock

OriginItemTypes = TxIn | TxInCond | TxOut | TxOutCond | TxPkey | TxSig | TxToken | TxReceipt | TxOutExt | TxTSD | TxOutCondSubtypeSrvStakeLock
ticker = NewType("ticker", str)
ledger_cache_rc = NewType("ledger_cache_rc", str)
datum_hash = NewType("datum_hash", str)


class CFLedgerCacheResponse(str, Enum):
    DAP_LEDGER_TX_CHECK_OK = "DAP_LEDGER_TX_CHECK_OK"
    DAP_LEDGER_TX_CHECK_NULL_TX = "DAP_LEDGER_TX_CHECK_NULL_TX"
    DAP_LEDGER_TX_CHECK_INVALID_TX_SIZE = "DAP_LEDGER_TX_CHECK_INVALID_TX_SIZE"
    DAP_LEDGER_TX_ALREADY_CACHED = "DAP_LEDGER_TX_ALREADY_CACHED"
    DAP_LEDGER_TX_CHECK_INVALID_TX_SIGN = "DAP_LEDGER_TX_CHECK_INVALID_TX_SIGN"
    DAP_LEDGER_TX_CHECK_IN_EMS_ALREADY_USED = "DAP_LEDGER_TX_CHECK_IN_EMS_ALREADY_USED"
    DAP_LEDGER_TX_CHECK_STAKE_LOCK_IN_EMS_ALREADY_USED = "DAP_LEDGER_TX_CHECK_STAKE_LOCK_IN_EMS_ALREADY_USED"
    DAP_LEDGER_TX_CHECK_EMISSION_NOT_FOUND = "DAP_LEDGER_TX_CHECK_EMISSION_NOT_FOUND"
    DAP_LEDGER_TX_CHECK_TX_NO_VALID_INPUTS = "DAP_LEDGER_TX_CHECK_TX_NO_VALID_INPUTS"
    DAP_LEDGER_TX_CHECK_TICKER_NOT_FOUND = "DAP_LEDGER_TX_CHECK_TICKER_NOT_FOUND"
    DAP_LEDGER_TX_CHECK_STAKE_LOCK_INVALID_TOKEN = "DAP_LEDGER_TX_CHECK_STAKE_LOCK_INVALID_TOKEN"
    DAP_LEDGER_TX_CHECK_STAKE_LOCK_NO_OUT_COND_FOR_IN_EMS = "DAP_LEDGER_TX_CHECK_STAKE_LOCK_NO_OUT_COND_FOR_IN_EMS"
    DAP_LEDGER_TX_CHECK_MULT256_OVERFLOW_EMS_LOCKED_X_RATE = "DAP_LEDGER_TX_CHECK_MULT256_OVERFLOW_EMS_LOCKED_X_RATE"
    DAP_LEDGER_TX_CHECK_NO_OUT_EXT_FOR_GIRDLED_IN_EMS = "DAP_LEDGER_TX_CHECK_NO_OUT_EXT_FOR_GIRDLED_IN_EMS"
    DAP_LEDGER_TX_CHECK_NO_OUT_ITEMS_FOR_BASE_TX = "DAP_LEDGER_TX_CHECK_NO_OUT_ITEMS_FOR_BASE_TX"
    DAP_LEDGER_TX_CHECK_TOKEN_EMS_VALUE_EXEEDS_CUR_SUPPLY = "DAP_LEDGER_TX_CHECK_TOKEN_EMS_VALUE_EXEEDS_CUR_SUPPLY"
    DAP_LEDGER_TX_CHECK_STAKE_LOCK_UNEXPECTED_VALUE = "DAP_LEDGER_TX_CHECK_STAKE_LOCK_UNEXPECTED_VALUE"
    DAP_LEDGER_TX_CHECK_STAKE_LOCK_TICKER_NOT_FOUND = "DAP_LEDGER_TX_CHECK_STAKE_LOCK_TICKER_NOT_FOUND"
    DAP_LEDGER_TX_CHECK_STAKE_LOCK_OTHER_TICKER_EXPECTED = "DAP_LEDGER_TX_CHECK_STAKE_LOCK_OTHER_TICKER_EXPECTED"
    DAP_LEDGER_TX_CHECK_OUT_ITEM_ALREADY_USED = "DAP_LEDGER_TX_CHECK_OUT_ITEM_ALREADY_USED"
    DAP_LEDGER_TX_CHECK_PREV_TX_NOT_FOUND = "DAP_LEDGER_TX_CHECK_PREV_TX_NOT_FOUND"
    DAP_LEDGER_TX_CHECK_PREV_OUT_ITEM_NOT_FOUND = "DAP_LEDGER_TX_CHECK_PREV_OUT_ITEM_NOT_FOUND"
    DAP_LEDGER_TX_CHECK_PKEY_HASHES_DONT_MATCH = "DAP_LEDGER_TX_CHECK_PKEY_HASHES_DONT_MATCH"
    DAP_LEDGER_TX_CHECK_PREV_OUT_ALREADY_USED_IN_CURRENT_TX = "DAP_LEDGER_TX_CHECK_PREV_OUT_ALREADY_USED_IN_CURRENT_TX"
    DAP_LEDGER_TX_CHECK_NO_VERIFICATOR_SET = "DAP_LEDGER_TX_CHECK_NO_VERIFICATOR_SET"
    DAP_LEDGER_TX_CHECK_VERIFICATOR_CHECK_FAILURE = "DAP_LEDGER_TX_CHECK_VERIFICATOR_CHECK_FAILURE"
    DAP_LEDGER_TX_CHECK_PREV_TICKER_NOT_FOUND = "DAP_LEDGER_TX_CHECK_PREV_TICKER_NOT_FOUND"
    DAP_LEDGER_TX_CHECK_PREV_TOKEN_NOT_FOUND = "DAP_LEDGER_TX_CHECK_PREV_TOKEN_NOT_FOUND"
    DAP_LEDGER_PERMISSION_CHECK_FAILED = "DAP_LEDGER_PERMISSION_CHECK_FAILED"
    DAP_LEDGER_TX_CHECK_SUM_INS_NOT_EQUAL_SUM_OUTS = "DAP_LEDGER_TX_CHECK_SUM_INS_NOT_EQUAL_SUM_OUTS"
    DAP_LEDGER_TX_CHECK_REWARD_ITEM_ALREADY_USED = "DAP_LEDGER_TX_CHECK_REWARD_ITEM_ALREADY_USED"
    DAP_LEDGER_TX_CHECK_REWARD_ITEM_ILLEGAL = "DAP_LEDGER_TX_CHECK_REWARD_ITEM_ILLEGAL"


class CFNetState(str, Enum):
    NET_STATE_OFFLINE = "NET_STATE_OFFLINE"
    NET_STATE_ONLINE = "NET_STATE_ONLINE"


class TSD(Enum):
    TYPE_UNKNOWN = 0x0000
    TYPE_TIMESTAMP = 0x0001
    TYPE_ADDRESS = 0x0002
    TYPE_VALUE = 0x0003
    TYPE_CONTRACT = 0x0004
    TYPE_NET_ID = 0x0005
    TYPE_BLOCK_NUM = 0x0006
    TYPE_TOKEN_SYM = 0x0007
    TYPE_OUTER_TX_HASH = 0x0008
    TYPE_SOURCE = 0x0009
    TYPE_SOURCE_SUBTYPE = 0x000A
    TYPE_DATA = 0x000B
    TYPE_SENDER = 0x000C
    TYPE_TOKEN_ADDRESS = 0x000D
    TYPE_SIGNATURS = 0x000E
    TYPE_UNIQUE_ID = 0x000F
    TYPE_BASE_TX_HASH = 0x0010
    TYPE_EMISSION_CENTER_UID = 0x0011
    TYPE_EMISSION_CENTER_VER = 0x0012
