import asyncio
import sys
import urllib

from DAP.Core import logIt
try:
    import tornado
except:
    logIt.warning("TORNADO not installed, external http-server will be unavailable")



import threading



def init_tornado_http(url, handler, port):

    if "tornado" not in sys.modules:
        raise BaseException("TORNADO not installed, external http-server will be unavailable")

    class Http:
        '''wrapper to emulate cellframe-node Http object'''
        '''must return query string + write data to response'''

        def __init__(self, trnd):
            self.trnd = trnd
        
        @property
        def query(self):
            return self.trnd.request.query

        def replyAdd(self, str):
            self.trnd.write(str)

    class HttpCode:
        '''wrapper to emulate cellframe-node http-responce-code object'''
        
        def __init__(self):
            pass

        def set(self, v):
            self.code = v

        def get(self):
            return self.code

    class MainHandler(tornado.web.RequestHandler):
        def set_default_headers(self):
            self.set_header("Content-Type", 'application/json')

        def get(self):
            http = Http(self)
            code = HttpCode()
            handler(http, code)
            self.set_status(code.get())
            self.finish()

    async def eventloop(url, handler, port):
        app = tornado.web.Application([
            (url, MainHandler),
        ])
        
        app.listen(port)
        await asyncio.Event().wait()

    print("Running asincio thread")
    x = threading.Thread(target=lambda: asyncio.run(eventloop(url, handler, port)))
    x.start()
    

    